function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/filter-panel/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import FilterBox from "@dftvue2-opentiny/vue-filter-box";
import Popover from "@dftvue2-opentiny/vue-popover";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dftvue2-opentiny/vue-theme/filter-panel/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "FilterPanel",
  emits: ["handle-clear", "visible-change"],
  components: {
    TinyPopover: Popover,
    TinyFilterBox: FilterBox
  },
  props: _extends({}, $props, {
    label: String,
    value: String,
    tip: String,
    popperClass: {
      type: String,
      default: ""
    },
    clearable: {
      type: Boolean,
      default: true
    },
    disabled: {
      type: Boolean,
      default: false
    },
    placement: {
      type: String,
      default: "bottom-start"
    },
    popperAppendToBody: {
      type: Boolean,
      default: true
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-filter-panel"
  }, [_c("tiny-popover", {
    ref: "popover",
    attrs: {
      "placement": _vm.placement,
      "visible-arrow": false,
      "popper-class": _vm.popperClass + " tiny-filter-panel__popover",
      "append-to-body": _vm.popperAppendToBody,
      "trigger": "manual"
    },
    on: {
      "show": _vm.popoverShow,
      "hide": _vm.popoverHide
    },
    scopedSlots: _vm._u([{
      key: "reference",
      fn: function fn() {
        return [_c("div", [_c("tiny-filter-box", {
          ref: "filterBox",
          attrs: {
            "show-close": _vm.clearable,
            "disabled": _vm.disabled,
            "label": _vm.label,
            "tip": _vm.tip,
            "value": _vm.value,
            "drop-down-visible": _vm.state.visible
          },
          on: {
            "click": _vm.togglePanel,
            "handle-clear": _vm.handleClear
          }
        })], 1)];
      },
      proxy: true
    }]),
    model: {
      value: _vm.state.visible,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "visible", $$v);
      },
      expression: "state.visible"
    }
  }, [_c("div", [_vm._t("default")], 2)])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var FilterPanel = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
FilterPanel.install = function(Vue) {
  Vue.component(FilterPanel.name, FilterPanel);
};
FilterPanel.version = version;
export {
  FilterPanel as default
};
